/* AppController */

#import <Cocoa/Cocoa.h>
#import "CheckerView.h"
#import "PreferencesCtrl.h"
#import "Checkers.h"


#define HUMANCOLOR			@"HumanChessmanColor"
#define DEFSKILL			@"ComputerDefSkill"
#define SHOWLEGALMOVES		@"ShowLegalMoves"
#define HUMANAUTOPASS		@"HumanAutoPass"
#define LASTMOVE			@"LastMove"
#define ANIMATIONEFF		@"AnomationEff"
#define SHOWCOORDINATION	@"ShowCoordination"


@class PreferencesCtrl;
@class aMoving;
@class Sinewave;

@interface AppController : NSObject
{
	IBOutlet NSTextField *BlackPoint;
	IBOutlet NSTextField *WhitePoint;
	IBOutlet NSButton *PassButton;
	IBOutlet NSButton *UndoButton;
	IBOutlet NSButton *BestMoveButton;
	IBOutlet NSButton *AllDoablesButton;
	IBOutlet NSProgressIndicator *BlackThinkingProgress;
	IBOutlet NSProgressIndicator *WhiteThinkingProgress;
	
/*	
	IBOutlet NSMenuItem *beginnerMenuItem;
	IBOutlet NSMenuItem *noviceMenuItem;
	IBOutlet NSMenuItem *expertMenuItem;
	IBOutlet NSMenuItem *masterMenuItem;
*/	
	IBOutlet NSTextField *InfoField;
	
	int human, computer;
	int depth, endgame_empty;
	Checkers *CurCheckers;
	
	NSMenuItem *curItem;
	
	BOOL bAutoPass;
	BOOL bShowMoves;
	BOOL bCanPass;
	BOOL bGameOver;
	
	BOOL bInBackProcessing;
	
	int nIndexofVoice;
	int nBlackPointCount;
	int nWhitePointCount;
		
	IBOutlet CheckerView *CView;
	
	//void *m_pBrain;
	
	PreferencesCtrl *preferencesCtrl;
	
	NSUndoManager *undo;
	IBOutlet NSDrawer *drawer;
	
	Sinewave *sinewave;
}

- (IBAction)showPreferencePanel:(id)sender;
- (void)setPlayerColor;

- (IBAction)OnNew:(id)sender;

- (IBAction)OnPass:(id)sender;
- (IBAction)OnUndo:(id)sender;
- (IBAction)OnBestDoable:(id)sender;
- (IBAction)OnAllDoables:(id)sender;
- (IBAction)OnSwap:(id)sender;
- (IBAction)OnLearntoPlay:(id)sender;
- (IBAction)OnContactMe:(id)sender;

- (void)OnPlayerDoneAtX:(int)x Y:(int)y;

- (void)NewComputerFirst;

- (Checkers *)CurCheckers;
- (BOOL)bInBackProcessing;
- (int)computer;

- (void)process;
- (void)beginProcessThread;
- (void)processThread:(id)obj;

- (int)callBrainwithMyself:(int)me Adversary:(int)adv;


- (void)beginBestDoableThread;
- (void)BestDoableThread:(id)obj;

- (void)placeAndDisplayAtX:(int)x Y:(int)y Myself:(int)me Adversary:(int)adv InThread:(BOOL)inThread;
- (void)unPlace:(aMoving*)mov;

- (void)displayGameOver;

- (void)handleAutoPassFlgChanged:(NSNotification *)note;
- (void)handleShowMovesFlgChanged:(NSNotification *)note;
- (void)handleLastMoveFlgChanged:(NSNotification *)note;
- (void)handleAnimationEffFlgChanged:(NSNotification *)note;
- (void)handleCoordinationFlgChanged:(NSNotification *)note;
- (void)handleSkillChanged:(NSNotification *)note;

- (void)handleExit:(NSNotification *)note;

@end
