//
//  CheckerView.h
//  Othello
//
//  Created by Nike on 5/19/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class BannerWinController;
@class AppController; 

@interface CheckerView : NSView 
{
	NSImage *BlackButton2D;
	NSImage *WhiteButton2D;
	NSImage *BlackButton2DLM;	//LM = Last Move
	NSImage *WhiteButton2DLM;

	NSImage *GreenButton2D;
	NSImage *GoldenButton2D;
	
	NSImage *BlackButtonSmall;
	NSImage *WhiteButtonSmall;
	NSImage *GreenButton;
	NSImage *GoldenButton;
	NSImage *Empty;
	NSImage *LstBlack;
	NSImage *LstWhite;
	
	NSMutableArray *ImageArray;
	
	
	AppController *appController;
	
	NSSpeechSynthesizer *speechSynth;
	
	int curX, curY;
	float curFlashState;
	
	BOOL bShowLastMove;
	BOOL bAnimationEff;
	BOOL bShowCoordinate;
	
	int base;
	
	BannerWinController *controller;
}

- (void)drawChecher;
- (void)drawBishop;
- (NSPoint)translatePoint:(NSPoint)pt;

- (void)SetLastMoveFlg:(BOOL)flg;
- (void)SetAnimationFlg:(BOOL)flg;
- (void)SetCoordination:(BOOL)flg;

//- (void)placeAndDisplayOthello:(int [][8])othello X:(int)x Y:(int)y Myself:(int)myself Adversary:(int)adversary;
//- (void)placeAndDisplayThread:(id)obj;
//- (void)beginPlaceAndDisplayThreadByOthello:(int [][8])othello X:(int)x Y:(int)y Myself:(int)myself Adversary:(int)adversary;
//- (void)process;
//- (void)processThread:(id)obj;
//- (void)beginProcessThread;
//- (void)cleanDoables;
//- (void)unPlace:(int[][8])oldOthello X:(int)x Y:(int)y Myself:(int)myself Adversary:(int)adversary;
//- (void)unPlace:(OthelloUndo *)othUndo;
//- (void)setPlayerColor;
//- (void)displayGameOver;


//- (int)	BlackPointCount;
//- (int)	WhitePointCount;

/*
- (void)handleVoiceMsgFlgChanged:(NSNotification *)note;
- (void)handleVoiceIndexChanged:(NSNotification *)note;
- (void)handleAutoPassFlgChanged:(NSNotification *)note;
- (void)handleShowMovesFlgChanged:(NSNotification *)note;
- (void)handleDrawerInited:(NSNotification *)note;
- (void)handleNewGame:(NSNotification *)note;
- (void)handleUndo:(NSNotification *)note;
- (void)handlePass:(NSNotification *)note;
- (void)handleAllDoables:(NSNotification *)note;
- (void)handleBestDoables:(NSNotification *)note;
- (void)flashCurMove:(NSNotification *)note;
*/

@end
